(* Krivine machine *)

(* Code generation *)

(* This program generates a temporary C file, to compile with gcc *)

open Globals;;
open Kall;;
open Pattern;;

let letone e s = 
   let rec let1 s = match s with
          [] ->
              output_string !oc "
       *tmp2 = NIL;";
              []
        | ((x, FPar) :: l) ->
              let p = pres x e in
              output_string !oc (if p then "
       h_malloc(henv,a);
#ifdef count
       nbr[2]++;
#endif
       *a = *context;
       a->cont = copytree(context->cont);
       *tmp2 = a;
       tmp2 = &a->next;
       context = context->next;"
              else "
       context = context->next;");
              let s = let1 l in
              if p then (x, FPar)::s
                   else s
        | ((x, LetVar (lbl,called))::l) ->
              if pres x e then begin
                 output_string !oc "
       *tmp2 = copytree(context);";
                 s
              end else
                 let1 l
in let1 s
;;

let split e1 e2 s = 
   let rec spl s = match s with
          [] ->
              output_string !oc "
       *tmp1 = NIL;
       *tmp2 = NIL;"; 
              ([],[])
        | ((x, FPar) :: l) ->
              let p1 = pres x e1 in
              let p2 = pres x e2 in
              output_string !oc (match (p1,p2) with
                 (true,true) -> "
       h_malloc(henv,a);
#ifdef count
       nbr[2]++;
#endif
       *a = *context;
       a->cont = copytree(context->cont);
       *tmp1 = context;
       tmp1 = &context->next;
       *tmp2 = a;
       tmp2 = &a->next;
       context = context->next;"
               | (true,false) -> "
       *tmp1 = context;
       tmp1 = &context->next;
       context = *tmp1;"
               | (false,true) -> "
       *tmp2 = context;
       tmp2 = &context->next;
       context = *tmp2;"
               | (false, false) -> "
       a = context;
       context = context->next;
       freetree(a->cont);
       h_free(henv,a);");
              let (s1,s2) = spl l in
              let s1'= if p1 then (x, FPar)::s1
                             else s1 in
              let s2'= if p2 then (x, FPar)::s2
                             else s2 in
              (s1',s2')
       | ((x, LetVar (lbl,called))::l) ->
              match (pres x e1, pres x e2) with
                 (true, true) -> output_string !oc "
       *tmp1 = copytree(context);
       *tmp2 = context;";
                                (s,s)
               | (false, false) -> spl l
               | (false, true) -> output_string !oc "
       *tmp1 = context;";
                                  (letone e1 l,s)
               | (true, false) -> output_string !oc "
       *tmp2 = context;
       tmp2 = tmp1;";
                                  (s,letone e2 l)
in spl s
;;

let splitenv e1 e2 l1out symtable =
   output_string !oc "
     { env_t *a, *c1, **tmp1 = &c1, **tmp2;
       h_malloc(henv,a);
       tmp2 = &a->cont;
       a->next = ep;
       ep = a;";
   if !mach = IrrevValue(C) then
       output_string !oc " 
       ep->l = _L;";
   let res = split e1 e2 symtable in
   output_string !oc "
       context = c1;";
   if !mach = IrrevValue(C) then
       output_string !oc (" 
       ep->v.addr = &&" ^ l1out ^ ";
     }")
   else
       output_string !oc (" 
       ep->addr = &&" ^ l1out ^ ";
     }");
   res
;;

let code_letref n lg called = 
  if n>0 then
  begin
     output_string !oc "
    { env_t *tmp = context, *tmp2;";
     if n=2 then
        output_string !oc "
      context = context->next;"
     else if n>2 then
        output_string !oc ("
      { short i;
        for (i=1; i<" ^ (string_of_int n) ^ "; i++)
            context = context->next;
      }");
     output_string !oc "
      tmp2 = context;
      context = context->next;
      tmp2->next = NIL;
      freetree(tmp);
    }"
  end;
  output_string !oc ("
    latexout(\"" ^ (string_of_int n) ^ " let ref\");
    goto " ^ lg ^ ";\n");
  called := true
;;

let code_globref lg called =
  output_string !oc ("
      freetree(context);
      context = NIL;
      latexout(\"global ref\");
      goto " ^ lg ^ ";\n");
  called := true
;;

let codecond code_expr symtable boolexpr ttexpr ffexpr =
  let l2 = new_label() in
  let (s1,s2) = splitenv boolexpr (Apply(ttexpr,ffexpr)) l2 symtable in
  output_string !oc ("
     latexout(\"cond ask\");");
  code_expr s1 boolexpr;
  output_string !oc ("\n"
     ^ l2 ^ ":
     if (s_top(vstack)) {
        s_pop(vstack);
        latexout(\"cond ans\");");
  code_expr s2 ttexpr;
  output_string !oc "
     } else {
        s_pop(vstack);
        latexout(\"cond ans\");";
  code_expr s2 ffexpr;
  output_string !oc "
     }"
;;

let ccode_xref n =
  output_string !oc "
    { env_t *tmp = context, *tmp2;
      void *tmpad;"; 
  if n=1 then
     output_string !oc "
      context = context->next;"
  else if n>1 then
     output_string !oc ("
      { short i;
        for (i=1; i<=" ^ (string_of_int n) ^ "; i++)
            context = context->next;
      }");
  output_string !oc ("
      tmpad = context->addr;
      tmp2 = context;
      context = context->cont;
      tmp2->cont = NIL;
      freetree(tmp);
      latexout(\"" ^ (string_of_int n) ^ " ref\");
      goto *tmpad;
    }\n")
;;

let codeop name code_expr symtable e1 e2 =
match name with
  "::" ->
  output_string !oc "
     if (s_top(dstack2) > 1) {
       s_top(dstack2)-=2;
       latexout(\"l*\");";
  code_expr symtable e2;
  output_string !oc "
     } else {
       if (s_top(dstack2) == 1) {
         s_pop(dstack2);
         latexout(\"i*\");
         s_push(vstack,ff);
         _DERREV(\"ff\");
       } else {
         s_pop(dstack2);
         latexout(\"h*\");";
  code_expr symtable e1;
  output_string !oc "
       }
     }"
| "and" ->
  let l2 = new_label() in 
  let (s1,s2) = splitenv e1 e2 l2 symtable in
  output_string !oc ("
    latexout(\"and ask\");");
  code_expr s1 e1;
  output_string !oc ("\n"
    ^ l2 ^ ":
    if (s_top(vstack)) {
      s_pop(vstack);
      latexout(\"and ans\");");
  code_expr s2 e2;
  output_string !oc "
    } else 
      _DERREV(\"and ans\")"
| "or" ->
  let l2 = new_label() in
  let (s1,s2) = splitenv e1 e2 l2 symtable in
  output_string !oc ("
    latexout(\"or ask\");");
  code_expr s1 e1;
  output_string !oc ("\n"
    ^ l2 ^ ":
    if (s_top(vstack) == 0) {
      s_pop(vstack);
      latexout(\"or ans\");");
  code_expr s2 e2;
  output_string !oc "
    } else 
      _DERREV(\"or ans\")"
| _ ->
  let l2 = new_label() 
  and l3 = new_label()
  and texname = match name with
         "%" -> "\\\\%"
       | "<=" -> "$<=$"
       | "<" -> "$<$"
       | "<>" -> "$<>$"
       | _    ->  name
  in let (s1,s2) = splitenv e1 e2 l2 symtable
  in output_string !oc ("
    latexout(\"" ^ texname ^ " ask 1\");");
    code_expr s1 e1;
    output_string !oc ("\n"
    ^ l2 ^ ":
    _DERNS(" ^ l3 ^ ",\"" ^ texname ^ " ask 2\")");
    code_expr s2 e2;
    output_string !oc ("\n"
    ^ l3 ^ ":
    { signed long tmp = s_top(vstack);
      s_pop(vstack);
      s_top(vstack) = (s_top(vstack) " ^ (match name with 
        "=" -> "=="
      | "<>" | "xor" -> "!="
      | _ -> name)
          ^ " tmp);
    }
    _DERREV(\"" ^ texname ^ " ans\")\n\n")
;;

let codelet x code_expr symtable e1 e2 =
   let l1out = new_label() in
   output_string !oc "
     { env_t *b, *a, **tmp1, **tmp2;
       h_malloc(henv,b);
       tmp1 = &b->cont;
       tmp2 = &b->next;";
   let (s1,s2) = split e1 e2 symtable in
   output_string !oc ("
       context = b; 
       context->addr = &&" ^ l1out ^ ";
       latexout(\"let decl\");
     }");
   code_expr ((x, FPar)::s2) e2;
   output_string !oc ("\n" ^ l1out ^ ":");
   code_expr s1 e1
;;

let machine = (["sflconfig.c"; "cknammacros.c"], Knam.code_fun, codecond, 
   ccode_xref, code_letref, code_globref, Knam.codenil, Knam.codelistask, 
   Knam.codecst, Knam.codeinternal, codeop, codelet, 
   Knam.codeaffint, Knam.codeaffbool, Knam.codeafflist, splitenv);;

