(* Call by value Krivine machine *)

(* Code generation *)

(* This program generates a temporary C file, to compile with gcc *)

open Globals;;
open Kall;;
open Cknam;;

let codecond code_expr symtable boolexpr ttexpr ffexpr =
  let l2 = new_label() in
  let (s1,s2) = splitenv boolexpr (Apply(ttexpr,ffexpr)) l2 symtable in
  output_string !oc ("
     latexout(\"cond ask\");");
  code_expr s1 boolexpr;
  output_string !oc ("\n"
     ^ l2 ^ ":
     { signed long tmpval = context->v.val;
       _POPCONTEXTVALUE
       latexout(\"cond ans\");
       if (tmpval) {");
  code_expr s2 ttexpr;
  output_string !oc "
       } else {";
  code_expr s2 ffexpr;
  output_string !oc "
       }
     }"
;;

let ccode_xref n =
  output_string !oc "
    { env_t *tmp = context;";
  if n=1 then
     output_string !oc "
      context = context->next;"
  else if n>1 then
     output_string !oc ("
      { short i;
        for (i=1; i<=" ^ (string_of_int n) ^ "; i++)
            context = context->next;
      }");
  output_string !oc ("
      if (context->l == _v) {
        signed long tmpval = context->v.val;
        context = tmp;
        _PUTVAL(tmpval,\"" ^ (string_of_int n) ^ " ref\")
      } else {
        void *tmpad = context->v.addr;
        env_t *tmp2 = context;
        context = context->cont;
        tmp2->cont = NIL;
        freetree(tmp);
        latexout(\"" ^ (string_of_int n) ^ " ref\");
        goto *tmpad;
      }
    }")
;;

let ccodelistask x =
  output_string !oc ("
     { env_t *a;
       h_malloc(henv,a);
       a->next = ep;
       ep = a;
       ep->cont = NIL;
       ep->l = _" ^ x ^ ";
     }
    latexout(\"" ^ x ^ "\");")
;;

let codeop name code_expr symtable e1 e2 =
match name with
  "::" ->
  let l1 = new_label() in
  output_string !oc ("\n"
     ^ l1 ^ ":
     switch (ep->l) {
      case _h :
            { _DERREV
              latexout(\"cons\");");
  code_expr symtable e1;
  output_string !oc "
            }
      case _l :
            { _DERREV
              latexout(\"cons\");";
  code_expr symtable e2;
  output_string !oc (" 
            }
      case _i :
            { _DERREV
              _PUTVAL(ff,\"cons-ff\")
            }
      case 0 :
          {  void *tmpad = ep->v.addr;
             ep->v.addr = &&" ^ l1 ^ ";
             _SWAP2
             latexout(\"cons\");
             goto *tmpad;
          }
     }")
| "and" ->
  let l2 = new_label() in
  let (s1,s2) = splitenv e1 e2 l2 symtable in
  output_string !oc ("
     latexout(\"and ask\");");
  code_expr s1 e1;
  output_string !oc ("\n"
     ^ l2 ^ ":
     if (context->v.val) {
       _POPCONTEXTVALUE
       latexout(\"and ans\");");
  code_expr s2 e2;
  output_string !oc "
     } else {
       void *tmpad = ep->v.addr;
       _DERREV
       latexout(\"and ans\");
       goto *tmpad;
     }"
| "or" ->
  let l2 = new_label() in
  let (s1,s2) = splitenv e1 e2 l2 symtable in
  output_string !oc ("
     latexout(\"or ask\");");
  code_expr s1 e1;
  output_string !oc ("\n"
     ^ l2 ^ ":
     if (context->v.val == 0) {
       _POPCONTEXTVALUE
       latexout(\"or ans\");");
  code_expr s2 e2;
  output_string !oc "
     } else {
       void *tmpad = ep->v.addr;
       _DERREV
       latexout(\"or ans\");
       goto *tmpad;
     }"
| _ ->
  let l2 = new_label()
  and l3 = new_label()
  and texname = match name with
         "%" -> "\\\\%"
       | "<=" -> "$<=$"
       | "<" -> "$<$"
       | "<>" -> "$<>$"
       | _    ->  name
  in let (s1,s2) = splitenv e1 e2 l2 symtable
  in output_string !oc ("
    latexout(\"" ^ texname ^ " ask 1\");");
  code_expr s1 e1;
  output_string !oc ("\n"
    ^ l2 ^ ":
    _ENVTOSTACK
    _DERNS(" ^ l3 ^ ")
    latexout(\"" ^ texname ^ " ask 2\");");
  code_expr s2 e2;
  output_string !oc ("\n"
    ^ l3 ^ ":
    { signed long tmpval = (ep->v.val) " ^ (match name with 
        "=" -> "=="
      | "<>" | "xor" -> "!="
      | _ -> name)
          ^ " (context->v.val);
      _DERREV
      _PUTVAL(tmpval,\"" ^ texname ^ " ans\")
    }")
;;

let codelet x code_expr symtable e1 e2 =
   let l = new_label() in
   let (s1,s2) = splitenv e1 e2 l symtable in
   output_string !oc "
    ep->l = 0;
    latexout(\"let decl\");";
   code_expr s1 e1;
   output_string !oc ("\n" ^ l ^ ":");
   code_expr ((x, FPar)::s2) e2
;;

let machine = (["sflconfig.c"; "ckvalmacros.c"], Kval.code_fun, codecond, 
   ccode_xref, Cknam.code_letref, Cknam.code_globref, Kval.codenil, 
   ccodelistask, Kval.codecst, Kval.codeinternal, codeop, codelet, 
   Kval.codeaffint, Kval.codeaffbool, Kval.codeafflist, Cknam.splitenv);;


