(* Krivine machine *)

(* Code generation *)

(* This program generates a temporary C file, to compile with gcc *)

open Globals;;
open Kall;;

let code_fun ()=
  output_string !oc "
     ep = ep->right;
     latexout(\"!\");"
;;

let code_xref n = 
  if n=0 then 
     output_string !oc "
    { env_t *tmp = ep->prev, *tmp2 = tmp->left;
      void *tmpad = tmp->addr;"
  else if n=1 then
     output_string !oc "
    { env_t *tmp = ep->prev->prev, *tmp2 = tmp->left;
      void *tmpad = tmp->addr;"
  else
     output_string !oc ("
    { env_t *tmp = ep, *tmp2;
      short i;
      void *tmpad;
      
      for (i=0; i<=" ^ (string_of_int n) ^ "; i++)
          tmp = tmp->prev;
      tmp2 = tmp->left;
      tmpad = tmp->addr;");
  output_string !oc ("
      tmp->left = NIL; /* Disconnect the restored env form the rest */
      putenv(tmp2);
      latexout(\"" ^ (string_of_int n) ^ " ref\");
      goto *tmpad;
    }\n")
;;

let code_letref n lg called = 
  if n=0 then
     output_string !oc ("
      latexout(\"" ^ (string_of_int n) ^ " let ref\");
      goto " ^ lg ^ ";\n")
  else
  begin
     if n=1 then 
        output_string !oc "
    { env_t *tmp = ep->prev;"
     else if n=2 then
        output_string !oc "
    { env_t *tmp = ep->prev->prev;"
     else
        output_string !oc ("
    { env_t *tmp = ep;
      short i;
      
      for (i=0; i<" ^ (string_of_int n) ^ "; i++)
          tmp = tmp->prev;");
     output_string !oc ("
      ep->prev->right = NIL;
      ep->prev = tmp->prev;
      if (ep->prev != NIL)
         ep->prev->right = ep;
      freetree(tmp);
      latexout(\"" ^ (string_of_int n) ^ " let ref\");
      goto " ^ lg ^ ";
    }\n")
  end;
  called := true
;;

let code_globref lg called =
  output_string !oc ("
      putenv(NIL);
      latexout(\"global ref\");
      goto " ^ lg ^ ";\n");
  called := true
;;

let machine = (["sflconfig.c"; "knammacros.c"], code_fun, Knam.codecond, 
    code_xref, code_letref, code_globref, Knam.codenil, Knam.codelistask, 
    Knam.codecst, Knam.codeinternal, Knam.codeop, Knam.letcode, 
    Knam.codeaffint, Knam.codeaffbool, Knam.codeafflist, Knam.nosplitenv);;    


