(* Call by need Krivine machine *)

(* Code generation *)

(* This program generates a temporary C file, to compile with gcc *)

open Globals;;
open Kall;;

let code_fun () =
  let l3 = new_label() in
  output_string !oc ("\n" ^ l3 ^ ":
     _UPDATE(&&" ^ l3 ^ ");
     { env_t *tmp = ep;
       ep=ep->next;
       tmp->next = context;
       context = tmp;
     }
     latexout(\"!\");")
;;

let codecond code_expr symtable boolexpr ttexpr ffexpr =
  let l2 = new_label() in
  output_string !oc ("
     _ASKVALPLACE(" ^ l2 ^ ")
     latexout(\"cond ask\");");
  code_expr symtable boolexpr;
  output_string !oc ("\n"
     ^ l2 ^ ":
     { signed long tmpval = ep->v.val;
       _DERREV       
       latexout(\"cond ans\");
       if (tmpval) {");
  code_expr symtable ttexpr;
  output_string !oc "
       } else {";
  code_expr symtable ffexpr;
  output_string !oc "
       }
     }"
;;

let gccode_xref n = 
  output_string !oc "
    { env_t *tmp = context;
      int flag = (context->nbrcopy==1);";
  if n=1 then
     output_string !oc "
      context = context->next;
      if (context->nbrcopy!=1) flag=0;"
  else if n>1 then
     output_string !oc ("
      { short i;
        for (i=1; i<=" ^ (string_of_int n) ^ "; i++) {
            context = context->next;
            if (context->nbrcopy!=1) flag=0;
        }
      }");
  (* if flag is 1, the context is only copied once, so
     freetree will discard it -> it's useless to PUTUPD in this case *)
  output_string !oc ("
      if (context->l == _v) {
          signed long tmpval = context->v.val;
          context = tmp;
          _PUTVAL(tmpval,\"" ^ (string_of_int n) ^ " ref\")
      } else {
          void *tmpad = context->v.addr;
          if ((flag==0) && (context->l != _cv))
             _PUTUPD(context);
          context = context->cont;
          if (context != NIL) context->nbrcopy++;
          freetree(tmp);
          latexout(\"" ^ (string_of_int n) ^ " ref\");
          goto *tmpad;
      }
    }\n")
;;

let codenil () =
  let l = new_label() in
  output_string !oc ("\n"
    ^ l ^ ":
    _UPDATE(&&" ^ l ^ ")
    if (ep->l == _i) {
      _DERREV
      _PUTVAL(tt,\"nil-tt\")
    } else {
      printf(\"Bad access to nil node\\n\");
      latexend();
      latexendall();
      exit(0);
    }\n\n")
;;

let gccodelistask x =
  output_string !oc ("
     { env_t *a;
       h_malloc(henv,a);
       a->next = ep;
       ep = a;
       ep->l = _" ^ x ^ ";
       ep->cont = NIL;
       ep->nbrcopy = 1;
     }
    latexout(\"" ^ x ^ "\");")
;;

let codecst s =
  output_string !oc ("
    _PUTVAL(" ^ s ^ ",\"" ^ s ^ "\")\n\n") 
;;
       
let codeinternal name appexpr =
  let l2 = new_label() in
  output_string !oc ("
    _ASKVALNS(ep->cont," ^ l2 ^ ")
    latexout(\"" ^ name ^ " ask\");");
  appexpr();
  output_string !oc ("\n"
    ^ l2 ^ ":
    { signed long tmpval = (ep->cont)->v.val" ^
        (match name with
            "iszero" | "not" -> " == 0"
          | "succ" -> " + 1"
          | "pred" -> " - 1"
          | _ -> failwith "Internal error : undefined language identifier")
    ^ ";
      _PUTVAL(tmpval,\"" ^ name ^ " ans\")
    }")
;;

let codeop name code_expr symtable e1 e2 =
match name with
  "::" ->
  let l1 = new_label() in
  output_string !oc ("\n" 
    ^ l1 ^ ":
    _UPDATE(&&" ^ l1 ^ ")
    if (ep->l != _i)
      {
         bool tmp = ep->l;
         _DERREV
         latexout(\"cons\");
         if (tmp == _h) {");
  code_expr symtable e1;
  output_string !oc "
         } else {";
  code_expr symtable e2;
  output_string !oc "
         }
      }
   else {
      _DERREV
      _PUTVAL(ff,\"cons-ff\")
    }"
| "and" ->
  let l2 = new_label()
  in output_string !oc ("
    _ASKVAL(ep->cont," ^ l2 ^ ")
    latexout(\"and ask\");");
  code_expr symtable e1;
  output_string !oc ("\n"
     ^ l2 ^ ":
     if ((ep->cont)->v.val) { 
       latexout(\"and ans\");");
  code_expr symtable e2;
  output_string !oc "
    } else
      _PUTVAL(ff,\"and ans\")"
| "or" ->
  let l2 = new_label()
  in output_string !oc ("
    _ASKVAL(ep->cont," ^ l2 ^ ")
    latexout(\"or ask\");");
  code_expr symtable e1;
  output_string !oc ("\n"
    ^ l2 ^ ":
    if ((ep->cont)->v.val == 0) { 
      latexout(\"or ans\");");
  code_expr symtable e2;
  output_string !oc "
    } else
      _PUTVAL(tt,\"or ans\")"
| _ ->
  let l2 = new_label()
  and l3 = new_label()
  and texname = match name with
         "%" -> "\\\\%"
       | "<=" -> "$<=$"
       | "<" -> "$<$"
       | "<>" -> "$<>$"
       | _    ->  name
  in output_string !oc ("
    _ASKVAL(ep->cont," ^ l2 ^ ")
    latexout(\"" ^ texname ^ " ask 1\");");
  code_expr symtable e1;
  output_string !oc ("\n"
    ^ l2 ^ ":
    _ASKVALPLACENS(" ^ l3 ^ ")
    latexout(\"" ^ texname ^ " ask 2\");");
  code_expr symtable e2;
  output_string !oc ("\n"
    ^ l3 ^ ":
    { signed long tmpval = (ep->next->cont)->v.val" 
                 ^ (match name with 
                       "=" -> "=="
                     | "<>" | "xor" -> "!="
                     | _ -> name)
                 ^ "(ep->v.val);
      _DERREV
      _PUTVAL(tmpval,\"" ^ texname ^ " ans\")
    }")
;;

let codelet x code_expr symtable e1 e2 =
   match e1 with
      Func(_,_) | Op("::",_,_) | Var "[]" ->
           (* If expression e1 cannot be simplified, it's useless to keep
              a cell in the environment to store its value; call-by-name
              is better in this case *)
           Knam.letcode x code_expr symtable e1 e2 
    | _ -> 
   let l = new_label() in
   output_string !oc ("
    _LETDECL(" ^ l ^ ")");
   code_expr ((x, FPar)::symtable) e2;
   output_string !oc ("\n" ^ l ^ ":");
   code_expr symtable e1
;;  

let codeaffint lblin called =
  let lblout = new_label() in
  output_string !oc ("
     _INIT(" ^ lblout ^ ")
     goto " ^ lblin ^ ";\n"
     ^ lblout ^ ":
     latexout(\"printing\");
     printf(\"%li\",ep->v.val);
     h_freeall(henv);");
  called := true
;;

let codeaffbool lblin called =
  let lblout = new_label() in
  output_string !oc ("
     _INIT(" ^ lblout ^ ")
     goto " ^ lblin ^ ";\n"
     ^ lblout ^ ":
     latexout(\"printing\");
     if (ep->v.val)
        printf(\"tt\");
     else
        printf(\"ff\");
     h_freeall(henv);");
  called := true
;;

let codeafflist lblin affelem called =
  called := true;
  let lblout = new_label() in
  output_string !oc ("
     printf(\"[\");
     s_push(dstack,0);
     do {
          s_top(dstack)++; /* i */
          _INIT(" ^ lblout ^ ")
          goto " ^ lblin ^ ";\n"
          ^ lblout ^ ":
          if (ep->v.val)
             break;
          h_freeall(henv);
          s_top(dstack)--; /* i -> h */
          if (s_top(dstack) != 0)
             printf(\"; \");");
  affelem called;
  output_string !oc ("
          s_top(dstack)+=2;/* one more l */
     } while (1);
     h_freeall(henv);
     s_pop(dstack);
     printf(\"]\");\n")
;;

let machine = (["sflconfig.c"; "gckneemacros.c"],
    code_fun, codecond, gccode_xref, Knam.gccode_letref, Knam.cgccode_globref,
    codenil, gccodelistask, codecst, codeinternal, codeop,
    codelet, codeaffint, codeaffbool, codeafflist, Knam.nosplitenv);;
    
