/* Macro include file for the Krivine machine */

#define NIL (env_t *) NULL
     
typedef struct env_s {
        struct env_s *cont, *next;
        void *addr;
} env_t;

stack_t vstack = s_init;
stack_t dstack = s_init;
stack_t dstack2 = s_init;
heap_t henv = h_init(env_t);
env_t *ep,*context;

#ifdef latex

void printenv(env_t *env)
{
  if (env == NIL) 
     fprintf(f,"\\carre");
  else {
     fprintf(f, "$<$");
     printenv(env->cont);
     fprintf(f, ",");
     printenv(env->next);
     fprintf(f, "$>$");
   }
};

char *latexpreamble()
{
  return "\\tvi\\quad#\\hfill\\quad&\n\
\\tvi\\hfill\\quad#\\hfill\\quad&\n\
\\tvi\\hfill\\quad#\\hfill\\quad&\n\
\\tvi\\hfill\\quad#\\quad&\n\
\\tvi\\hfill\\quad#\\quad\\tvi\\cr\n\
\\noalign{\\hrule}\n\
Instruc.&   Environment& Stack& Data access& Data\\cr\n";
};

void latexprintline(char *s)
{
  stack_t *tmp = vstack;
  stack_t *d = dstack2;

  fprintf(f,"{\\it %s}& ",s);
  printenv(context);
  fprintf(f, "& ");
  printenv(ep);
  fprintf(f, "& ");
  while (! s_empty(d))
  { ulng i;

    for (i=1; i<=s_top(d)/2; i++)
       fprintf(f, "l:");
    if ((s_top(d) & 1) == 0)
       fprintf(f, "h:");
    else
       fprintf(f, "i:");
    s_next(d);
  }
  fprintf(f, "\\carre & ");  
  while (! s_empty(tmp)) 
  {
     fprintf(f, "%li:", s_top(tmp));
     s_next(tmp);
  }
  fprintf(f,"\\carre\\cr\n");
};

#endif

#define _INIT(lbl) \
     copydatac();\
     context = NIL;\
     h_malloc(henv,ep);\
     ep->addr = &&lbl;\
     ep->cont = ep->next = NIL;\
     latexout("beginning");


#define _DERNS(l1out,mess) \
     { env_t *a;\
       h_malloc(henv,a);\
       a->next = ep;\
       ep = a;\
       ep->cont = NIL;\
       ep->addr = &&l1out;\
       latexout(mess);\
     }

#define _DERREV(mess) \
    { void *add = ep->addr;\
      env_t *tmp = ep->next;\
      freetree(context);\
      context = ep->cont;\
      h_free(henv,ep);\
      ep = tmp;\
      latexout(mess);\
      goto *add;\
    }

env_t *copytree(env_t *p)
{
  if (p != NIL) {
    env_t *tmp;
    h_malloc(henv,tmp);
#ifdef count
    nbr[2]++;
#endif
    tmp->next = copytree(p->next);
    tmp->cont = copytree(p->cont);
    tmp->addr = p->addr;
    return tmp;
  } else return NIL;
};

void freetree(env_t *p)
{
  if (p != NIL) {
    freetree(p->next);
    freetree(p->cont);
    h_free(henv,p);
  };
};

void copydatac()
{
  stack_t tmp = dstack;
  
  dstack2.nbr = NBLK-1;
  dstack2.lastblk = SNIL;
  while (! s_empty(tmp)) {
    s_push(dstack2, s_top(tmp));
    s_next(tmp);
  }
};
