/* Macro include file for the Krivine machine */

#define NIL (env_t *) NULL

typedef struct env_s {
        struct env_s *prev, *left, *right;
        void *addr;
} env_t;

stack_t vstack = s_init;
stack_t dstack = s_init;
stack_t dstack2 = s_init;
heap_t henv = h_init(env_t);
env_t *ep,*context;

#ifdef latex

void printenv(env_t *env)
{
  if (env == NIL) 
     fprintf(f,"\\carre");
  else {
     if (env == ep)
        fprintf(f,"{\\it ep:}");
     fprintf(f, "$<$");
     printenv(env->left);
     fprintf(f, ",");
     printenv(env->right);
     fprintf(f, "$>$");
   }
};

char *latexpreamble()
{
  return "\\tvi\\quad#\\hfill\\quad&\n\
\\tvi\\hfill\\quad#\\hfill\\quad&\n\
\\tvi\\hfill\\quad#\\quad&\n\
\\tvi\\hfill\\quad#\\quad\\tvi\\cr\n\
\\noalign{\\hrule}\n\
Instruc.&   Environment& Data access& Data\\cr\n";
};

void latexprintline(char *s)
{
  vs_t *tmp = vstack;
  dat_ac_t *d = dstack;

  fprintf(f,"{\\it %s}& ",s);
  printenv(context);
  fprintf(f, "& ");
  while (! s_empty(d))
  {
    for (i=1; i<=s_top(d)/2; i++)
       fprintf(f, "l:");
    if ((s_top(d) & 1) == 0)
       fprintf(f, "h:");
    else
       fprintf(f, "i:");
    s_next(d);
  }
  fprintf(f, "\\carre & ");  
  while (! s_empty(tmp)) 
  {
     fprintf(f, "%li:", s_top(tmp));
     s_next(tmp);
  }
  fprintf(f,"\\carre\\cr\n");
};

#endif

#define _INIT(lbl) \
     copydatac();\
     h_malloc(henv,ep);\
     context = ep;\
     ep->addr = &&lbl;\
     ep->left = ep->prev = NIL;\
     h_malloc(henv,ep->right);\
     ep->right->right = ep->right->left = NIL;\
     ep->right->addr = NULL;\
     ep->right->prev = ep;\
     latexout("beginning");


#define _DER(l1out) \
     { env_t *a;\
       h_malloc(henv,a);\
       a->right = ep->right;\
       if (a->right != NIL) a->right->prev = a;\
       a->left = ep->left;\
       a->addr = ep->addr;\
       a->prev = ep;\
       ep->right = a;\
       ep->left = copyenv();\
       ep->addr = &&l1out;\
     }

#define _DERNS(l1out,mess) \
     { env_t *a;\
       h_malloc(henv,a);\
       a->right = ep->right;\
       if (a->right != NIL) a->right->prev = a;\
       a->left = ep->left;\
       a->addr = ep->addr;\
       a->prev = ep;\
       ep->right = a;\
       ep->left = NIL;\
       ep->addr = &&l1out;\
       latexout(mess);\
     }

#define _DERREV(mess) \
    { void *add = ep->addr;\
      env_t *tmp = ep->right;\
      putenv(ep->left);\
      ep->addr = tmp->addr;\
      ep->left = tmp->left;\
      if (tmp->left != NIL)\
         ep->left->prev = ep;\
      ep->right = tmp->right;\
      if (tmp->right != NIL)\
         ep->right->prev = ep;\
      h_free(henv,tmp);\
      latexout(mess);\
      goto *add;\
    }

env_t *copytree(env_t *p, env_t *pr)
{
  if (p != NIL) {
    env_t *a;
    h_malloc(henv,a);
#ifdef count
    nbr[2]++;
#endif
    a->left = copytree(p->left, NIL);
    a->right = copytree(p->right,a);
    a->prev = pr;
    a->addr = p->addr;
    return a;
  }
  else return NIL;
};


env_t *copyenv()
{
  env_t *res;

  if (ep->prev != NIL) {
    ep->prev->right = NIL; /* Disconnect the stack from the environment */
    res = copytree(context, NIL);
    ep->prev->right = ep; /* Reconnect stack and environment */
    return res;
  }
  else return NIL;
};

void freetree(env_t *p)
{
  if (p != NIL) {
    freetree(p->left);
    freetree(p->right);
    h_free(henv,p);
  }
};

void putenv(env_t *p)
{
  if (ep->prev != NIL) {
    ep->prev->right = NIL; /* disconnect stack/environment */
    freetree(context);
  }
  if (p != NIL) {
    context = p;
    while (p->right != NIL)
       p = p->right;
    p->right = ep;
    ep->prev = p;
  }
  else {
    context = ep;
    ep->prev = NIL;
  }
};

void copydatac()
{
  stack_t tmp = dstack;
  
  dstack2.nbr = NBLK-1;
  dstack2.lastblk = SNIL;
  while (! s_empty(tmp)) {
    s_push(dstack2, s_top(tmp));
    s_next(tmp);
  }
};
