/* Macro include file for the question stack machine */

#define QNIL (qs_t *) NULL

typedef struct ques {
        env_t *envi;
        void *addr;
        struct ques *next;
} qs_t;

heap_t hqs = h_init(qs_t);
qs_t *qs = QNIL;

#define _QASK(lbl) \
    { qs_t *tmp;\
      h_malloc(hqs, tmp);\
      tmp->envi = copytree(context, NIL);\
      tmp->addr = &&lbl;\
      tmp->next = qs;\
      qs = tmp;\
    }

#define _QASKNS(lbl) \
    { qs_t *tmp;\
      h_malloc(hqs, tmp);\
      tmp->envi = NIL;\
      tmp->addr = &&lbl;\
      tmp->next = qs;\
      qs = tmp;\
    }

#define _QANS(mess) \
    if (qs->envi != NIL) {\
       freetree(context);\
       putenv(qs->envi);\
     }\
    { void *add = qs->addr;\
      qs_t *tmp = qs->next;\
      h_free(hqs, qs);\
      qs = tmp;\
      latexout(mess);\
      goto *add;\
    }

cont_t *copycontent(cont_t *p)
{
  if (p != CNIL) {
    cont_t *a;
    h_malloc(hcont, a);
#ifdef count
    nbr[2]++;
#endif
    a->d = p->d;
    a->next = copycontent(p->next);
    return a;
  }
  else return CNIL;
};

env_t *copytree(env_t *p, env_t *pr)
{
  if (p != NIL) {
    env_t *a;
    h_malloc(henv, a);
#ifdef count
    nbr[2]++;
#endif
    a->left = copytree(p->left,a);
    a->right = copytree(p->right,a);
    a->prev = pr;
    a->content = copycontent(p->content);
    return a;
  }
  else return NIL;
};



void freecont(cont_t *p)
{
  if (p != CNIL) {
    freecont(p->next);
    h_free(hcont, p);
  }
};

void freetree(env_t *p)
{
  if (p != NIL) {
    freetree(p->left);
    freetree(p->right);
    freecont(p->content);
    h_free(henv, p);
  }
};

void putenv(env_t *p)
{
  context = p;
  while (p->right != NIL)
     p = p->right;
  ep = p;
};
